package eu.dty.attributor.controller

import io.swagger.v3.oas.annotations.security.SecurityRequirement
import org.slf4j.Logger
import org.slf4j.LoggerFactory
import org.springframework.http.codec.multipart.FilePart
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestPart
import org.springframework.web.bind.annotation.RestController
import reactor.core.publisher.Mono
import java.nio.file.Path
import java.nio.file.Paths
import java.util.function.Function

@RestController
@RequestMapping("/deviceMeta/sensorImage")
//@SecurityRequirement(name = "security_auth")
class DeviceMetaController {

    val logger: Logger = LoggerFactory.getLogger(DeviceMetaController::class.java)
    private val basePath: Path = Paths.get("/home/rdusane/UI/attributor-backend/attributor-backend/src/main/resources/files")

    //single file upload
    @PostMapping("/upload")
    fun uploadFile(@RequestPart("file") filePartMono: Mono<FilePart>): Mono<Void?>? {
        logger.info("hello: " + basePath)
        return filePartMono
            .doOnNext { fp: FilePart -> logger.info("Received File : " + fp.filename()) }
            .flatMap(Function<FilePart, Mono<*>> { fp: FilePart ->
                fp.transferTo(basePath.resolve(fp.filename()))
            })
            .then()
    }
}