package eu.dty.attributor.controller


import eu.dty.attributor.models.DeviceMetadata
import eu.dty.attributor.service.DeviceMetadataService
import io.swagger.v3.oas.annotations.security.SecurityRequirement
import org.slf4j.Logger
import org.slf4j.LoggerFactory
import org.springframework.http.HttpStatus
import org.springframework.http.MediaType
import org.springframework.http.codec.multipart.FilePart
import org.springframework.web.bind.annotation.*
import org.springframework.web.multipart.MultipartFile
import reactor.core.publisher.Mono
import java.nio.file.Path
import java.nio.file.Paths
import java.util.function.Function


@RestController
@RequestMapping("/deviceMetadata")
@SecurityRequirement(name = "security_auth")
class DeviceMetadataController(val deviceMetadataService: DeviceMetadataService) {

  //  private val basePath: Path = Paths.get("./src/main/resources/files/")
  val logger: Logger = LoggerFactory.getLogger(DeviceMetadataController::class.java)

  @PostMapping("/upload/{serialNumber}")
   fun uploadFile(@PathVariable serialNumber: String,@RequestPart("sensorImage") filePartMono: Mono<FilePart>): Mono<Void?>? {
     // var serialNumber="ser_num3";
      return filePartMono
           .flatMap(Function<FilePart, Mono<*>> { fp: FilePart ->
               deviceMetadataService.addImage(fp.content(), serialNumber )
                      })
           .then()
   }

   @PostMapping("/saveMetadata")
    @ResponseStatus(HttpStatus.CREATED)
    fun saveMetaData(@RequestBody devMetadataReq: DeviceMetadata): Mono<DeviceMetadata> {
       print(devMetadataReq)
        return deviceMetadataService.addDeviceMetadata(devMetadataReq)
    }
}