package eu.dty.attributor.service

//import eu.dty.attributor.dto.toDeviceMetadata

import eu.dty.attributor.models.DeviceMetadata
import eu.dty.attributor.repository.DeviceMetadataRepository
import org.springframework.core.io.buffer.DataBuffer
import org.springframework.core.io.buffer.DataBufferUtils
import org.springframework.stereotype.Service
import reactor.core.publisher.Flux
import reactor.core.publisher.Mono


@Service
class DeviceMetadataService(private val deviceMetadataRepository: DeviceMetadataRepository) {

    fun addDeviceMetadata(devMetadataReq: DeviceMetadata): Mono<DeviceMetadata> =
        deviceMetadataRepository.save(devMetadataReq)

    fun addImage(file: Flux<DataBuffer>, serial_number: String): Mono<Void> {

        return DataBufferUtils.join(file)
            .flatMap { buffer: DataBuffer ->
                val result = ByteArray(buffer.readableByteCount())
                buffer.read(result)
                DataBufferUtils.release(buffer)
                deviceMetadataRepository.saveFile(result, serial_number);
            }

    }


}