CREATE TABLE IF NOT EXISTS devicesConfig
    (
    serial_number          varchar(100)                         NOT NULL PRIMARY KEY,
    product_name        varchar(100)                         NOT NULL,
    product_text        varchar(100)                         NOT NULL,
    dev_model           varchar(100)                          NOT NULL,
    vendor_name         varchar(100)                         NOT NULL,
    vendor_text         varchar(100)                         NOT NULL,
    product_id          varchar(50)                          NOT NULL,
    firmware_ver        varchar(100)                         NOT NULL,
    hardware_version    varchar(100)                         NOT NULL,
    sensorImage         bytea                                NOT NULL
      );

CREATE TABLE IF NOT EXISTS users
    (
    user_id             varchar(100)                        NOT NULL PRIMARY KEY,
    user_name           varchar(100)                        NOT NULL,
    user_email          varchar(100)                        NOT NULL,
    contact             varchar(100)                        NOT NULL
    );

CREATE TABLE IF NOT EXISTS deviceMetadata
    (
    id                  INT GENERATED BY DEFAULT AS IDENTITY NOT NULL PRIMARY KEY,
    sensor_name         varchar                             NOT NULL,
    serial_number       varchar(50)                         NOT NULL,
    lokation            varchar(100)                        NOT NULL,
    scada_instance      varchar(100)                        NOT NULL,
    sensorImage         bytea
    FOREIGN KEY (serial_number) references devicesconfig (serial_number)
    );


----Below queries must be executed after the device initialization process ends and voucher is downloaded--------------------
---------------------------------------------------------------------------------------------------------------

    insert into attributor.public.devicesconfig (product_id, product_name, product_text, dev_model,
                                                   vendor_name, vendor_text,serial_number, firmware_ver, hardware_version, sensor_image)
    VALUES ('pid2' , 'pname2' , 'ptext2' , 'dev_mod2' , 'ven_name2' , 'ven_text2' , 'ser_num3' , 'firm_ver_2' , 'hard_ver_2', byteasend('/home/rdusane/UI/attributor-backend/attributor-backend/src/main/resources/files/ViewDetails.jpeg'));

    insert into attributor.public.deviceMetadata (sensor_name, serial_number, lokation, scada_instance)
    VALUES ('sensor_1' , 'ser_num1' , 'lokation' , 'scada' );

    insert into attributor.public.users (user_id, user_name, user_email, contact)
    VALUES ('' , '' , '' , '' );







